# Qt qmake integration with Google Protocol Buffers compiler protoc
#
# To compile protocol buffers with qt qmake, specify PROTOS variable and
# include this file
#
# Example:
# BITSIZE = $$system(getconf LONG_BIT)
# if (contains(BITSIZE, 64)) {
#     LIBS += /usr/lib/x86_64-linux-gnu/libprotobuf.so
# }
# if (contains(BITSIZE, 32)) {
#     LIBS += /usr/lib/libprotobuf.so
# }
# PROTOS = a.proto b.proto
# include(protobuf.pri)
#
# By default protoc looks for .proto files (including the imported ones) in
# the current directory where protoc is run. If you need to include additional
# paths specify the PROTOPATH variable

message("Generating protocol buffer classes from .proto files.")

#PROTOS = \
#    $$PWD/game_event.proto \
#    $$PWD/ssl_vision_geometry.proto \
#    $$PWD/ssl_gc_common.proto \
#    $$PWD/referee.proto \
#    $$PWD/ssl_vision_detection.proto \
#    $$PWD/ssl_wrapper.proto \
#    $$PWD/rcon.proto \
#    $$PWD/savestate.proto \
#    $$PWD/ssl_geometry_legacy.proto \
#    $$PWD/ssl_wrapper_legacy.proto \
#    $$PWD/ssl_refbox_log.proto \
#    $$PWD/ssl_simulation_error.proto \
#    $$PWD/ssl_simulation_config.proto \
#    $$PWD/ssl_simulation_control.proto \
#    $$PWD/ssl_simulation_robot_control.proto \
#    $$PWD/ssl_simulation_robot_feedback.proto \
#    $$PWD/ssl_simulation_synchronous.proto

PROTOS = \
    $$PWD/*.proto

LIBS +=\
    -lprotobuf

 
protobuf_decl.name = protobuf headers
protobuf_decl.input = PROTOS
protobuf_decl.output = $${OUT_PWD}/${QMAKE_FILE_BASE}.pb.h
protobuf_decl.commands = protoc --cpp_out=$${OUT_PWD} --proto_path=${QMAKE_FILE_IN_PATH} --proto_path=$${OUT_PWD} ${QMAKE_FILE_NAME}

protobuf_decl.variable_out = HEADERS
QMAKE_EXTRA_COMPILERS += protobuf_decl
 
protobuf_impl.name = protobuf sources
protobuf_impl.input = PROTOS
protobuf_impl.output = $${OUT_PWD}/${QMAKE_FILE_BASE}.pb.cc
protobuf_impl.depends = $${OUT_PWD}/${QMAKE_FILE_BASE}.pb.h
protobuf_impl.commands = $$escape_expand(\n)
protobuf_impl.variable_out = SOURCES
QMAKE_EXTRA_COMPILERS += protobuf_impl
